package ru.pricepulse.parsingservice.ozon_parser.service;

import lombok.RequiredArgsConstructor;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

@Service
@RequiredArgsConstructor
public class PartitionService {

    private final JdbcTemplate jdbcTemplate;

    public boolean checkPartitionExists(String partitionName) {
        String query = "SELECT to_regclass('public." + partitionName + "')";
        String result = jdbcTemplate.queryForObject(query, String.class);
        return result != null;
    }

    public void createPartition(String partitionName, String startDate, String endDate) {
        String createPartitionSQL = "CREATE TABLE IF NOT EXISTS " + partitionName +
            " PARTITION OF price_history FOR VALUES FROM ('" + startDate + "') TO ('" + endDate + "')";
        jdbcTemplate.execute(createPartitionSQL);
    }

}
