package ru.pricepulse.parsingservice.ozon_parser.service.scheduler;

import lombok.RequiredArgsConstructor;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Service;
import ru.pricepulse.parsingservice.config.properties.OzonConfigProperties;
import ru.pricepulse.parsingservice.ozon_parser.service.marketplace.ozon.parsing.ParsingService;

@Service
@RequiredArgsConstructor
public class OzonProductUpdater {

    private final OzonConfigProperties properties;
    private final ParsingService ozonParsingService;

    @Scheduled(fixedRate = 3600000)
    public void updateOzonProducts() {
        properties.getCategoriesUrls()
                  .forEach(ozonParsingService::processCategory);
    }

}
